VERSION 1.0 CLASS
BEGIN
  MultiUse = -1  'True
  Persistable = 0  'NotPersistable
  DataBindingBehavior = 0  'vbNone
  DataSourceBehavior  = 0  'vbNone
  MTSTransactionMode  = 0  'NotAnMTSObject
END
Attribute VB_Name = "clsPluginInterface"
Attribute VB_GlobalNameSpace = True
Attribute VB_Creatable = True
Attribute VB_PredeclaredId = False
Attribute VB_Exposed = True
'------------------------------------------------------------------
'Your main class module HAS to be called "clsPluginInterface",
'and saved as "clsPluginInterface.cls", so the client/server
'will know how to identify it. You must also have 3 (THREE)
'functions included in this module:

' -ClientRun(ByVal ClientForm as Object)
'       + Called by the client to show the plugin
' -Identify()
'       + Called by both the client and server to identify the plugin
' -ReturnFunction(ByVal ReturnString As String)
'       + Called by the client when returning the result of a plugin

'If this seems confusing, just look around this plugin and it
'should make sense -- what this plugin is set up to do is to
'call the function "ServerFunction" on the server side, then
'return a message to the "ReturnFunction" within the plugin on
'the client side.
'------------------------------------------------------------------

Option Explicit
Public TheServerForm As Object
Public Function ClientRun(ByVal ClientForm As Object) As String
'------------------------------------------------------------------
'Occurs when the plugin is ran from within the client
'------------------------------------------------------------------
Set frmMain.TheClientForm = ClientForm
frmMain.Show

'------------------------------------------------------------------
'The string that is returned to the client will display in the
'client's status bar
'------------------------------------------------------------------
ClientRun = Identify & " Activated"
End Function
Public Function Identify() As String
'------------------------------------------------------------------
'The ID Of the Plugin - This can be ANYTHING you want
'------------------------------------------------------------------
Identify = "Plugin Template v" & App.Major & "." & App.Minor & "." & App.Revision
End Function
Public Function ReturnFunction(ByVal ReturnString As String) As String
'------------------------------------------------------------------
'ReturnString: String that is returned to the plugin on the client side
'------------------------------------------------------------------
MsgBox "Results of plugin: " & ReturnString
End Function
Public Function ServerFunction(Argument As String, ServerForm As Object) As String
'------------------------------------------------------------------
'ServerFunction: Our custom function to be performed at the
'server side of the plugin.
'------------------------------------------------------------------

'------------------------------------------------------------------
'The SendPluginData function will send data directly to the plugin on
'the client side. This is useful for anything that needs to be sent
'out periodically instead of just after the plugin is initialized
'*** You MUST specify the plugin id (Identify)!! ***
'
'The SendCommand and SendPluginData functions are meant to send text
'only. So if you want to set up something for file transfer or something
'similiar, you'll have to add your own winsock functions.
'------------------------------------------------------------------
Set TheServerForm = ServerForm
TheServerForm.SendPluginData "Message to be sent to the ReturnFunction", Identify

'------------------------------------------------------------------
'This will return data to the plugin on the client side just like
'it does in the SendPluginData function.
'------------------------------------------------------------------
ServerFunction = "Plugin Activated"
End Function
